{1999.04.21}
Unit PaulFile;

Interface

Const
     {  䠩}
     CReadOnly  = 0;    {쪮 ⥭}
     CWriteOnly = 1;    {쪮 }
     CReadWrite = 2;    {  ⥭}
     {࠭祭    䠩}
     CDenyAll   = 8;    {⥭  }
     CDenyWrite = 16;   {}
     CDenyRead  = 24;   {⥭}
     CDenyNone  = 32;   {祣}

Type
    FByte = File Of Byte;
    PByte = ^Byte;

    FileRec = record
                Handle: Word;
                Mode: Word;
                RecSize: Word;
                Private: array[1..26] of Byte;
                UserData: array[1..16] of Byte;
                Name: array[0..79] of Char;
              end;

Function FileOpen(Var F:FByte;B:Byte;S:String):Integer;
Function FileRead(var F:FByte;P:PByte;Count:Word):Integer;
Function FileReadStr(var F:FByte;Count:Byte):String;
Function FileWrite(var F:FByte;P:PByte;Count:Word):Integer;
Function SetFAttr(const S:String; Attr:Word):Word;
Function GetFAttr(const S:String):Word;

Function DirCreate(s:String):Integer;

Implementation

Function FileOpen(Var F:FByte;B:Byte;S:String):Integer;
{----------[ 뢠 䠩 S <- F   ० B
}
Begin
     Assign(F,s);
     FileMode:=B;
     {$I-}
     Reset(F);
     {$I+}
     FileOpen:=IOResult;
End; {FileOpen}

Function FileRead(var F:FByte;P:PByte;Count:Word):Integer;
{----------[ ⠥  䠩 F Count   P^
             ᫨ Count=0 ⠥  ப
}
Var {Q:^Word;}
    Save:Word;
    b:Byte;
Begin
     If Count=0 Then Begin
        {$I-}
        Read(F,b);
        {$I+}
        FileRead:=IOResult;
        P^:=b;
        Inc(P);
        Count:=b;
     End;
     If Count>0 Then Begin
        Save:=FileRec(F).RecSize;
        FileRec(F).RecSize:=Count;
        {Q:=@F;
        Inc(Q,2);
        Save:=Q^;
        Q^:=Count;}
        {$I-}
        Read(F,P^);
        {$I+}
        FileRead:=IOResult;
        FileRec(F).RecSize:=Save;
        {Q^:=Save;}
     End;
End; {FileRead}

function FileReadStr(var F:FByte;Count:Byte):String;
var s:string;
begin
 if FileRead(F,@s[1],Count)=0 then byte(s[0]):=Count else s:='';
 FileReadStr:=s;
end;

Function FileWrite(var F:FByte;P:PByte;Count:Word):Integer;
{----------[   䠩 F Count   P^
             ᫨ Count=0   ப
}
Var {Q:^Word;}
    Save:Word;
    b:Byte;
Begin
     If Count=0 Then Begin
        b:=P^;
        Inc(P);
        Count:=b;
        {$I-}
        Write(F,b);
        {$I+}
        FileWrite:=IOResult;
     End;
     If Count>0 Then Begin
        Save:=FileRec(F).RecSize;
        FileRec(F).RecSize:=Count;
        {Q:=@F;
        Inc(Q,2);
        Save:=Q^;
        Q^:=Count;}
        {$I-}
        Write(F,P^);
        {$I+}
        FileWrite:=IOResult;
        FileRec(F).RecSize:=Save;
        {Q^:=Save;}
     End;
End; {FileWrite}

Function DirCreate(s:String):Integer;
{----------[ ᮧ  ⠫  મ S
              ⠫  稢 '\'
}
Var s1:String;
    i,err:Integer;
Begin
     s1:='';
     i:=0;
     err:=0;
     While (i<Ord(s[0]))And(err=0) Do Begin
        Inc(i);
        If s[i]='\' Then Begin
           {$I-}
           MkDir(s1);
           {$I+}
           err:=IOResult;
           If err=5 Then err:=0;
        End;
        s1:=s1+s[i];
     End;
End; {DirCreate}

Function SetFAttr(const S: String; Attr: Word) : Word; assembler;
asm
  push ds
  lds  dx, S
  inc  dx
  mov  cx, Attr
  mov  ax, 4301h
  int  21h
  jc   @@1
  sub  ax,ax
@@1:
  pop  ds
end;

Function GetFAttr(const S: String): Word; assembler;
asm
  push ds
  lds  dx, S
  inc  dx
  mov  ax, 4300h
  int  21h
  pop  ds
  mov  ax, cx
end;
End.