{2003.03.24}
Unit ampcrypt;

interface

uses PaulFile;

function DecryptStr(var F:FByte;var Key:byte;Size:byte):string;
function DecryptByte(var F:FByte;var Key:byte):byte;
function DecryptWord(var F:FByte;var Key:byte):word;
function DecryptDword(var F:FByte;var Key:byte):LongInt;
function TestBit(L:LongInt;b:byte):boolean;
function SetBit(L:LongInt;b:byte):LongInt;
function ClrBit(L:LongInt;b:byte):LongInt;
procedure BitOperation(var L:LongInt;b:byte;f:boolean);
procedure EncryptStr(var F:FByte;var Key:byte;Size:byte;s:string);
procedure EncryptByte(var F:FByte;var Key:byte;b:byte);
procedure EncryptWord(var F:FByte;var Key:byte;w:word);
procedure EncryptDword(var F:FByte;var Key:byte;L:LongInt);

implementation

function DecryptStr(var F:FByte;var Key:byte;Size:byte):string;
var s:string;
    w:word;
    b:byte;
    i:integer;
begin
 s:='';
 DecryptStr:=s;
 if Size=2 then begin
  if FileRead(F,@w,2)<>0 then exit;
  w:=w xor (Key+11111);
 end else if Size=1 then begin
  if FileRead(F,@b,1)<>0 then exit;
  w:=Key xor b;
  Key:=b;
 end;
 if w>0 then begin
  w:=byte(w);
  if FileRead(F,@s[1],w)<>0 then exit;
  byte(s[0]):=w;
  for i:=1 to w do begin
   byte(s[i]):=byte(s[i]) xor Key;
   Inc(Key,w);
  end;
 end;
 DecryptStr:=s;
end;

function DecryptByte(var F:FByte;var Key:byte):byte;
var b:byte;
begin
 if FileRead(F,@b,1)<>0 then b:=0 else begin
  b:=Key xor b;
  Inc(Key);
 end;
 DecryptByte:=b;
end;

function DecryptWord(var F:FByte;var Key:byte):word;
var w:word;
begin
 if FileRead(F,@w,2)<>0 then w:=0 else begin
  w:=w xor (Key+11111);
  Inc(Key);
 end;
 DecryptWord:=w;
end;

function DecryptDword(var F:FByte;var Key:byte):LongInt;
var L:LongInt;
begin
 if FileRead(F,@L,4)<>0 then L:=0 else begin
  L:=L xor (Key+1111111111);
  Inc(Key);
 end;
 DecryptDword:=L;
end;

function TestBit(L:LongInt;b:byte):boolean;
begin
 {TestBit:=boolean(L and (1 shl b));}
 TestBit:=not((L and (1 shl b))=0);
end;

function SetBit(L:LongInt;b:byte):LongInt;
begin
 SetBit:=(L or (1 shl b));
end;

function ClrBit(L:LongInt;b:byte):LongInt;
begin
 ClrBit:=(L and not (1 shl b));
end;

procedure BitOperation(var L:LongInt;b:byte;f:boolean);
begin
 if f then L:=SetBit(L,b)else L:=ClrBit(L,b);
end;

procedure EncryptStr(var F:FByte;var Key:byte;Size:byte;s:string);
var w:word;
    b:byte;
    i:integer;
begin
 b:=byte(s[0]);
 if Size=2 then begin
  w:=b xor (Key+11111);
  if FileWrite(F,@w,2)<>0 then exit;
 end else if Size=1 then begin
  w:=Key xor b;
  if FileWrite(F,@w,1)<>0 then exit;
  Key:=w;
 end;
 if b>0 then begin
  for i:=1 to b do begin
   byte(s[i]):=byte(s[i]) xor Key;
   Inc(Key,b);
  end;
  if FileWrite(F,@s[1],b)<>0 then exit;
 end;
end;

procedure EncryptByte(var F:FByte;var Key:byte;b:byte);
begin
  b:=Key xor b;
  Inc(Key);
  FileWrite(F,@b,1);
end;

procedure EncryptWord(var F:FByte;var Key:byte;w:word);
begin
  w:=w xor (Key+11111);
  Inc(Key);
  FileWrite(F,@w,2);
end;

procedure EncryptDword(var F:FByte;var Key:byte;L:LongInt);
begin
  L:=L xor (Key+1111111111);
  Inc(Key);
  FileWrite(F,@L,4);
end;
end.
