{2003.07.19}
program ampdmp2;
uses ampcrypt, PaulFile, PaulStr;
const sig  = 'AMPL'#0#0;
      endl = '#ENDL';
      endp = '*#ENDPICLIST#*';
      splitter:string[1] = #0;
      dop  = '            ';
var F:FByte;
    out:Text;
    Key,b1,b2:byte;
    s:string;
    L,flag:LongInt;
    flag0,flag1,flag2,flag3,flag5,flag6,flag7,flag9,flagSDL:boolean;

procedure die(s:string);
begin
 writeln(s);
 halt(1);
end;

function Read1(b:boolean):boolean;
var flag,f3,f5,f6:LongInt;
    f1,f2:byte;
    level,f4:word;
    s,s1:string;
begin
 Read1:=true;
 write(out,'.'+HexStr(FilePos(F),3)+': dw ');
 level:=DecryptWord(F,Key);writeln(out,HexStr(level,2),' ; level=');
 f5:=0;f6:=0;
 write(out,'.'+HexStr(FilePos(F),3)+': dd ');
 flag:=DecryptDword(F,Key);writeln(out,HexStr(flag,4),' ; type=');
 if(TestBit(flag,0))then f1:=0 else
 if(TestBit(flag,1))then f1:=1 else
 if(TestBit(flag,2))then f1:=2 else
 if(TestBit(flag,3))then f1:=3 else
 if(TestBit(flag,4))then f1:=0;
 writeln(out,dop+'; f1= ',HexStr(f1,1));
 if(TestBit(flag,14))then begin
   write(out,'.'+HexStr(FilePos(F),3)+': db ');
   f2:=DecryptByte(F,Key);writeln(out,HexStr(f2,1),' ; f2=');
 end else f2:=b1;
 writeln(out,dop+'; f2= ',HexStr(f2,1));

 write(out,'.'+HexStr(FilePos(F),3)+': db ''');
 s:=DecryptStr(F,Key,2);writeln(out,s,''',0 ; N=');
 if(s=endl)and(level=word(-1))and(flag=15) then Read1:=false else begin
  if b then begin
    write(out,'.'+HexStr(FilePos(F),3)+': db ''');
    s1:=DecryptStr(F,Key,2);writeln(out,s1,''',0 ;');
  end else s1:='';
  writeln(out,dop+'; MF,F,FN= ',s1);
 end;
end;

procedure Read2;
var b:byte;
    w:word;
    s:string;
begin
 b:=DecryptByte(F,Key);writeln(out,b);
 if b=0 then begin
  w:=DecryptWord(F,Key);writeln(out,w);
  flagSDL:=TestBit(w,0);writeln(out,'SDL=',byte(flagSDL));
  s:=DecryptStr(F,Key,2);
  while(s<>endp)and(s<>'')do begin
   writeln(out,DecryptStr(F,Key,2));
   if flagSDL then writeln(out,DecryptStr(F,Key,2));
   s:=DecryptStr(F,Key,2);
  end;
  writeln(out,s);
 end;
end;

begin
 Writeln('Advanced Musical Player''s cfg-files dumper 2.2 by Paul Lee (c) 2003');
 if ParamCount=0 then begin
    Writeln;
    Writeln('   Usage: ampdmp2.exe <in-file> [<out-file>]');
    Writeln;
    exit;
 end;
 if FileOpen(F,CReadWrite+CDenyWrite,ParamStr(1))=0 then begin
  if ParamCount<2 then Assign(out,'out.dmp') else Assign(out,ParamStr(2));
  Rewrite(out);
  if ParamCount>2 then splitter:=ParamStr(3);
  flag5:=false;
  Key:=13;
  if FileReadStr(F,6)<>sig then die('Error');
  seek(F,8);
  writeln(out,'.'+HexStr(FilePos(F),3)+': db ''',DecryptStr(F,Key,1),''',0 ; CD=');
  writeln(out,'.'+HexStr(FilePos(F),3)+': db ''',DecryptStr(F,Key,1),''',0 ; CDRUS=');
  write(out,'.'+HexStr(FilePos(F),3)+': dd ');
  flag:=DecryptDword(F,Key);writeln(out,HexStr(flag,4),' ; flags');

  if(DecryptStr(F,Key,1)<>sig)or(TestBit(flag,4))
   then die('Error');
  flag0:=TestBit(flag,0);
  flag1:=TestBit(flag,1);
  flag2:=TestBit(flag,2);
  flag3:=TestBit(flag,3);
  flag5:=flag2 and TestBit(flag,5);
  flag6:=TestBit(flag,6);
  flag7:=TestBit(flag,7);
  flag9:=flag1 and TestBit(flag,9);

  writeln(out,dop+'; f0 PVT=  ',byte(flag0));
  writeln(out,dop+'; f1 PSSH= ',byte(flag1));
  writeln(out,dop+'; f2 PVV=  ',byte(flag2));
  writeln(out,dop+'; f3 DL=   ',byte(flag3));
  writeln(out,dop+'; f4 ???   ',byte(TestBit(flag,4)));
  writeln(out,dop+'; f5 ???   ',byte(TestBit(flag,5)));
  writeln(out,dop+'; f6 ???   ',byte(flag6));
  writeln(out,dop+'; f7 BS=   ',byte(flag7));
  writeln(out,dop+'; f9 BSV=  ',byte(TestBit(flag,9)));

  writeln(out,'.'+HexStr(FilePos(F),3)+': db ''',DecryptStr(F,Key,2),''',0 ; T=');
  write(out,'.'+HexStr(FilePos(F),3)+': db ');
  b1:=DecryptByte(F,Key);writeln(out,HexStr(b1,1),' ; Charset=');
  write(out,'.'+HexStr(FilePos(F),3)+': db ');
  b2:=DecryptByte(F,Key);writeln(out,HexStr(b2,1),' ; TextLanguage=');
  writeln(out,dop+';============================================');
  write(out,'.'+HexStr(FilePos(F),3)+': dw ');
  flag:=DecryptWord(F,Key);writeln(out,HexStr(flag,2),' ; count1=');
  while flag>0 do begin
   write(out,'.'+HexStr(FilePos(F),3)+': dd ');
   L:=DecryptDword(F,Key);writeln(out,HexStr(L,4),' ; CP=');
   write(out,'.'+HexStr(FilePos(F),3)+': db ''');
   s:=DecryptStr(F,Key,1);writeln(out,s,''',0 ; P=');
   write(out,'.'+HexStr(FilePos(F),3)+': db ''');
   s:=DecryptStr(F,Key,1);writeln(out,s,''',0 ; FN=');
   write(out,'.'+HexStr(FilePos(F),3)+': db ');
   L:=DecryptByte(F,Key);writeln(out,HexStr(L,1),' ; II=');
   write(out,'.'+HexStr(FilePos(F),3)+': db ');
   L:=DecryptByte(F,Key);writeln(out,HexStr(L,1),' ; ???');
   Dec(flag);
  end;
  writeln(out,dop+';============================================');
  write(out,'.'+HexStr(FilePos(F),3)+': dd ');
  L:=DecryptDword(F,Key);writeln(out,HexStr(L,4),' ; count2=');
  if L>0 then begin
   while Read1(true)do;
  end;
  writeln(out,dop+';============================================');
  write(out,'.'+HexStr(FilePos(F),3)+': dd ');
  L:=DecryptDword(F,Key);writeln(out,HexStr(L,4),' ; count3=');
  if(TestBit(flag,5))and(L>0) then begin
   Read2;
  end;
  writeln(out,dop+';============================================');
  write(out,'.'+HexStr(FilePos(F),3)+': dd ');
  L:=DecryptDword(F,Key);writeln(out,HexStr(L,4),' ; count4=');
  if(TestBit(flag,9))and(L>0) then begin
   Read2;
  end;
  writeln(out,dop+';============================================');
  close(out);
  close(F);
 end;
end.