{2003.11.23}
{2003.10.08 - port to Delphi}
{2003.07.19}
{2003.03.24}
program ampdec2;
{$APPTYPE CONSOLE}
uses ampcrypt, plFile;
const sig  = 'AMPL'#0#0;
      endl = '#ENDL';
      endp = '*#ENDPICLIST#*';
var F:FByte;
    out:Text;
    splitter:string[1] = #0;
    Key,b1,b2:byte;
    L,flag:LongInt;
    flag0,flag1,flag2,flag3,flag5,flag6,flag7,flag9,flagSDL:boolean;

procedure die(s:string);
begin
 writeln(s);
 halt(1);
end;

function Read1(b:boolean):boolean;
var flag,f3,f5,f6:LongInt;
    f1,f2:byte;
    level,f4:word;
    s,s1:string;
begin
 Read1:=true;
 level:=DecryptWord(F,Key);{writeln(out,';word=',level);}
 f5:=0;f6:=0;
 flag:=DecryptDword(F,Key);{writeln(out,';dword=',flag);}
 if(TestBit(flag,0))then f1:=0 else
 if(TestBit(flag,1))then f1:=1 else
 if(TestBit(flag,2))then f1:=2 else
 if(TestBit(flag,3))then f1:=3 else
 if(TestBit(flag,4))then f1:=0;
 {writeln(out,';f1 = ',f1);}
 if(TestBit(flag,14))then f2:=DecryptByte(F,Key)else f2:=b1;
 if(TestBit(flag,14))then writeln(out,';byte=',f2);
 s:=DecryptStr(F,Key,2);
 if(s=endl)and(level=word(-1))and(flag=15) then Read1:=false else begin
  if b then s1:=DecryptStr(F,Key,2) else s1:='';
{ver 2.2}{if level=0 then write(out,'M');write(out,'F');if level>1 then write(out,'N');}
  if flag=$10 then write(out,'M');write(out,'F');
  if(flag>=2)and(flag<=15)then write(out,'N');
  write(out,'='+s1+splitter+'N=');
 end;
 writeln(out,s);
end;

procedure Read2;
var b:byte;
    w:word;
    s:string;
begin
 b:=DecryptByte(F,Key);writeln(out,b);
 if b=0 then begin
  w:=DecryptWord(F,Key);writeln(out,w);
  flagSDL:=TestBit(w,0);writeln(out,'SDL=',byte(flagSDL));
  s:=DecryptStr(F,Key,2);
  while(s<>endp)and(s<>'')do begin
   writeln(out,DecryptStr(F,Key,2));
   if flagSDL then writeln(out,DecryptStr(F,Key,2));
   s:=DecryptStr(F,Key,2);
  end;
  writeln(out,s);
 end;
end;

begin
 Writeln('Advanced Musical Player''s cfg-files decoder 2.2 by Paul Lee (c) 2003');
 if ParamCount=0 then begin
    Writeln;
    Writeln('   Usage: ampdec2.exe <in-file> [<out-file> [<splitter>]]');
    Writeln;
    exit;
 end;
 if FileOpen(F,CReadWrite+CDenyWrite,ParamStr(1))<>0 then die('Can''t open file: '+ParamStr(1));
 if ParamCount<2 then Assign(out,'out.txt') else Assign(out,ParamStr(2));
 {$I-}
 Rewrite(out);
 {$I+}
 if IOResult<>0 then die('Can''t create output file');
 if ParamCount>2 then splitter:=ParamStr(3);
 flag5:=false;
 Key:=13;
 if FileReadStr(F,6)<>sig then die('Error');
 seek(F,8);
 writeln(out,'CD=',DecryptStr(F,Key,1));
 writeln(out,'CDRUS=',DecryptStr(F,Key,1));
 flag:=DecryptDword(F,Key);{writeln(out,';version:dword=',flag);}
 if(DecryptStr(F,Key,1)<>sig)or(TestBit(flag,4))
  then die('Error');
 flag0:=TestBit(flag,0);
 flag1:=TestBit(flag,1);
 flag2:=TestBit(flag,2);
 flag3:=TestBit(flag,3);
 flag5:=flag2 and TestBit(flag,5);
 flag6:=TestBit(flag,6);
 flag7:=TestBit(flag,7);
 flag9:=flag1 and TestBit(flag,9);
 writeln(out,'PVT=',byte(flag0));
 writeln(out,'PSSH=',byte(flag1));
 writeln(out,'PVV=',byte(flag2));
 if flag3 then writeln(out,'DL=',byte(flag3));
 if TestBit(flag,5) then writeln(out,'F5=',byte(TestBit(flag,5)));
 if flag6 then writeln(out,'F6=',byte(flag6));
 if flag7 then writeln(out,'BS=',byte(flag7));
 if TestBit(flag,9) then writeln(out,'BSV=',byte(TestBit(flag,9)));
 writeln(out,'T=',DecryptStr(F,Key,2));
 b1:=DecryptByte(F,Key);
 if b1<>0 then writeln(out,'Charset=',b1);
 b2:=DecryptByte(F,Key);
 if b1<>0 then writeln(out,'TextLanguage=',b2);
 flag:=DecryptWord(F,Key);{writeln(out,';count1:word=',flag);}
 while flag>0 do begin
  L:=DecryptDword(F,Key);
  write(out,'P='''+DecryptStr(F,Key,1)+
       ''' FN='''+DecryptStr(F,Key,1)+
       ''' II=',DecryptByte(F,Key));
  if L<>0 then write(out,' CP=',L);
  writeln(out);
  DecryptByte(F,Key);
  Dec(flag);
 end;
 writeln(out,'EndOfCFG');
 L:=DecryptDword(F,Key);
 {writeln(out,';count2:dword=',L);}
 if L>0 then begin
  while Read1(true)do;
 end;
 L:=DecryptDword(F,Key);
 {writeln(out,';count3:dword=',L);}
 if(TestBit(flag,5))and(L>0) then begin
  Read2;
 end;
 L:=DecryptDword(F,Key);
 {writeln(out,';count4:dword=',L);}
 if(TestBit(flag,9))and(L>0) then begin
  Read2;
 end;
 close(out);
 close(F);
end.