{2003.11.23 - port to FPC}
{2003.03.24}
Unit ampcrypt;

interface

function DecryptStr(F:longint;var Key:byte;Size:byte):string;
function DecryptByte(F:longint;var Key:byte):byte;
function DecryptWord(F:longint;var Key:byte):word;
function DecryptDword(F:longint;var Key:byte):LongInt;
function TestBit(L:LongInt;b:byte):boolean;
function SetBit(L:LongInt;b:byte):LongInt;
function ClrBit(L:LongInt;b:byte):LongInt;
procedure BitOperation(var L:LongInt;b:byte;f:boolean);
procedure EncryptStr(F:longint;var Key:byte;Size:byte;s:string);
procedure EncryptByte(F:longint;var Key:byte;b:byte);
procedure EncryptWord(F:longint;var Key:byte;w:word);
procedure EncryptDword(F:longint;var Key:byte;L:LongInt);

implementation

uses plFile,SysUtils;

function DecryptStr(F:longint;var Key:byte;Size:byte):string;
var w:word;
    b:byte;
    i:integer;
begin
 result:='';
 if Size=2 then begin
  if(FilePos(F)>=FileSize(F))or(FileRead(F,w,2)=-1)then exit;
  w:=w xor (Key+11111);
 end else if Size=1 then begin
  if FileRead(F,b,1)=-1 then exit;
  w:=Key xor b;
  Key:=b;
 end;
 if w>0 then begin
  w:=byte(w);
  if(FilePos(F)>=FileSize(F))or(FileRead(F,result[1],w)=-1)then exit;
  byte(result[0]):=w;
  for i:=1 to w do begin
   byte(result[i]):=byte(result[i]) xor Key;
   Inc(Key,w);
  end;
 end;
end;

function DecryptByte(F:longint;var Key:byte):byte;
begin
 if(FilePos(F)>=FileSize(F))or(FileRead(F,result,1)=-1)then result:=0 else begin
  result:=Key xor result;
  Inc(Key);
 end;
end;

function DecryptWord(F:longint;var Key:byte):word;
begin
 if(FilePos(F)>=FileSize(F))or(FileRead(F,result,2)=-1)then result:=0 else begin
  result:=result xor (Key+11111);
  Inc(Key);
 end;
end;

function DecryptDword(F:longint;var Key:byte):LongInt;
begin
 if(FilePos(F)>=FileSize(F))or(FileRead(F,result,4)=-1)then result:=0 else begin
  result:=result xor (Key+1111111111);
  Inc(Key);
 end;
end;

function TestBit(L:LongInt;b:byte):boolean;
begin
 TestBit:=not((L and (1 shl b))=0);
end;

function SetBit(L:LongInt;b:byte):LongInt;
begin
 SetBit:=(L or (1 shl b));
end;

function ClrBit(L:LongInt;b:byte):LongInt;
begin
 ClrBit:=(L and not (1 shl b));
end;

procedure BitOperation(var L:LongInt;b:byte;f:boolean);
begin
 if f then L:=SetBit(L,b)else L:=ClrBit(L,b);
end;

procedure EncryptStr(F:longint;var Key:byte;Size:byte;s:string);
var w:word;
    b:byte;
    i:integer;
begin
 b:=byte(s[0]);
 if Size=2 then begin
  w:=b xor (Key+11111);
  if FileWrite(F,w,2)=-1 then exit;
 end else if Size=1 then begin
  w:=Key xor b;
  if FileWrite(F,w,1)=-1 then exit;
  Key:=w;
 end;
 if b>0 then begin
  for i:=1 to b do begin
   byte(s[i]):=byte(s[i]) xor Key;
   Inc(Key,b);
  end;
  if FileWrite(F,s[1],b)=-1 then exit;
 end;
end;

procedure EncryptByte(F:longint;var Key:byte;b:byte);
begin
  b:=Key xor b;
  Inc(Key);
  FileWrite(F,b,1);
end;

procedure EncryptWord(F:longint;var Key:byte;w:word);
begin
  w:=w xor (Key+11111);
  Inc(Key);
  FileWrite(F,w,2);
end;

procedure EncryptDword(F:longint;var Key:byte;L:LongInt);
begin
  L:=L xor (Key+1111111111);
  Inc(Key);
  FileWrite(F,L,4);
end;
end.
